// CreditsView.cpp -- implementation for the CreditsView class



#include "CreditsView.h"


// Constructor
CreditsView::CreditsView(BRect frame, const char *name)
 : BView(frame, name, B_FOLLOW_ALL, B_WILL_DRAW)
{
  // Nothing to do here...
}


// Over-ride the virtual draw for the view, and display credits
void CreditsView::Draw(BRect r)
{
  // Dislpay some credits in the config view
  BFont font;
  font_height height;
  float y_pos, font_size, tmp;
  
  
  // Fill view with UI color
  this->SetLowColor(ui_color(B_PANEL_BACKGROUND_COLOR));
  this->FillRect(this->Bounds(), B_SOLID_LOW);


  // Get current font info
  this->GetFont(&font); 
  font.GetHeight(&height);


  // Remember what the current font size is...
  font_size = font.Size();
  
  // Figure out where to place this text - need height info
  //  ( * 2 here because two lines will be done in this size)
  tmp = 2 * (height.ascent + height.descent);
  
  // Go to a larger font size
  font.SetSize(font_size + 10);  

  // Figure out where to place this text - need height for new font size
  font.GetHeight(&height);
  
  // Set starting row position
  y_pos = (this->Bounds().Height() - tmp - height.ascent - height.descent)/2;
  
  
  // Draw the title, slightly larger font
  this->SetHighColor(0, 0, 0);
  this->SetFont(&font, B_FONT_ALL);
  this->MovePenTo(
   ((this->Bounds().right / 2) - (this->StringWidth(CREDITS_SSNAME) / 2) ), y_pos);
  
  this->DrawString(CREDITS_SSNAME, strlen(CREDITS_SSNAME), NULL);
  y_pos += (height.ascent + height.descent);
  
  
  // Go back to standard size font
  font.SetSize(font_size); 
  this->SetFont(&font, B_FONT_ALL);
  font.GetHeight(&height);

  // Version and date
  this->MovePenTo(
   ((this->Bounds().right / 2) - (this->StringWidth(CREDITS_VERSION) / 2) ), y_pos);
  this->DrawString(CREDITS_VERSION, strlen(CREDITS_VERSION), NULL);
  
  // Leave some extra space
  y_pos += height.ascent + height.descent;
  
  // Credit line
  this->MovePenTo(
   ((this->Bounds().right / 2) - (this->StringWidth(CREDITS_AUTHOR) / 2) ), y_pos);
  this->DrawString(CREDITS_AUTHOR, strlen(CREDITS_AUTHOR), NULL);
}


